<template>
  <v-data-table
    :headers="headers"
    :items="desserts"
    sort-by="createdAt"
    class="elevation-1"
    :loading="loading"
    loading-text="Загрузка... Пожалуйста ждите"
    :height="height + 'px'"
  >
    <template v-slot:item.full_name="{ item }">
      <p>{{`${item.name} ${item.surname} ${item.patronymic}`}}</p>
    </template>
    <template v-slot:item.status="{ item }">
      <v-chip v-if="item.status" x-small color="green" style="color: white">Активен</v-chip>
      <v-chip v-else x-small color="gray">Не активен</v-chip>
    </template>
    <template v-slot:item.block="{ item }">
      <v-chip v-if="!item.block" x-small color="green" style="color: white">Не блок.</v-chip>
      <v-chip v-else x-small color="red" style="color: #FFFFFF">Блок</v-chip>
    </template>
    <template v-slot:item.roles="{ item }">
      <span v-for="role in item.roles" :key="role">
        <span v-if="role === 'ADMIN'">Админ</span>
        <span v-if="role === 'suHOS'">супер РОП</span>
        <span v-if="role === 'HOS'">РОП</span>
        <span v-if="role === 'SALESMAN'">Менеджер</span>
        <span v-if="role === 'LAWYER'">Юрист</span>
        <span v-if="role === 'LEADSMAN'">Лидогенератор</span>
        <span v-if="role === 'FINANCIER'">Финансист</span>
      </span>
    </template>
    <template v-slot:item.createdAt="{ item }">
      <p>{{formatDate(item.createdAt, true)}}</p>
    </template>
    <template v-slot:item.updatedAt="{ item }">
      <p>{{formatDate(item.updatedAt, true)}}</p>
    </template>
    <template v-slot:top>
      <v-toolbar flat>
        <v-toolbar-title>Управление пользователями</v-toolbar-title>
        <v-divider
          class="mx-4"
          inset
          vertical
        ></v-divider>
        <v-spacer></v-spacer>
        <v-dialog v-model="dialog" max-width="700px">
          <template v-slot:activator="{ on, attrs }">
            <v-btn
              color="primary"
              dark
              class="mb-2"
              v-bind="attrs"
              v-on="on"
            >
              Добавить пользователя
            </v-btn>
          </template>
          <v-form v-model="valid">
            <v-card>
              <v-card-title>
                <span class="text-h5">{{ formTitle }}</span>
              </v-card-title>
              <v-card-text>
                <v-container>
                  <v-row>
                    <v-col
                      cols="12"
                    >
                      <div class="d-flex">
                        <v-text-field :label="formLogin" v-model="editedItem.username" :value="editedItem.username"/>
                        <v-text-field label="Телефон" class="mx-2" v-model="editedItem.phone" :value="editedItem.phone"/>
                        <v-text-field label="Email" v-model="editedItem.email" :value="editedItem.email"/>
                      </div>
                      <div class="d-flex">
                        <v-text-field label="Имя" v-model="editedItem.name" :value="editedItem.name"/>
                        <v-text-field label="Фамилия" class="mx-2" v-model="editedItem.surname" :value="editedItem.surname"/>
                        <v-text-field label="Отчество" v-model="editedItem.patronymic" :value="editedItem.patronymic"/>
                      </div>
                      <div class="d-flex">
                        <v-text-field label="Город" v-model="editedItem.city" :value="editedItem.city"/>
                        <v-text-field label="Сайт" class="mx-2" v-model="editedItem.website" :value="editedItem.website"/>
                        <v-select
                          v-model="editedItem.roles[0]"
                          :items="roles"
                          item-text="value"
                          flat
                          solo
                          single-line
                          label="Роль"
                          placeholder="Роль"
                          :rules="[v => !!v || 'Укажите роль']"
                        >
                          <template v-slot:item="{ item }">
                            <div v-if="item.value === 'ADMIN'">Админ</div>
                            <div v-if="item.value === 'suHOS'">супер РОП</div>
                            <div v-if="item.value === 'HOS'">РОП</div>
                            <div v-if="item.value === 'SALESMAN'">Менеджер</div>
                            <div v-if="item.value === 'LAWYER'">Юрист</div>
                            <div v-if="item.value === 'LEADSMAN'">Лидогенератор</div>
                            <div v-if="item.value === 'FINANCIER'">Финансист</div>
                          </template>
                        </v-select>
                      </div>
                      <div v-if="editedItem.roles[0] === 'LEADSMAN'" class="d-flex">
                        <v-text-field label="Укажите сайты через запятую" hint="Например: avtouristhelp.ru, avtourist.com," v-model="editedItem.leadsman" :value="editedItem.leadsman"/>
                      </div>
                      <v-text-field
                        :label="formPassword"
                        v-model="editedItem.password"
                        :value="editedItem.password"
                        :rules="formTitle === 'Новый пользователь' && [v => (v.length < 11 && v.length) || 'Не более 10 символов', v => v.length > 3 || 'Не менее 4 символов']"
                      />
                      <div class="d-flex">
                        <v-textarea label="О себе" class="mr-2" v-model="editedItem.about" :value="editedItem.about"/>
                        <v-row style="flex-basis: 40%">
                          <v-col cols="12"><v-text-field label="Дата регистрации" disabled v-model="editedItem.createdAt" :value="editedItem.createdAt"/></v-col>
                          <v-col cols="12"><v-text-field label="Дата изменения" disabled v-model="editedItem.updatedAt" :value="editedItem.updatedAt"/></v-col>
                        </v-row>
                      </div>
                      <div class="d-flex">
                        <v-sheet class="pa-2">
                          <v-switch
                            v-model="editedItem.status"
                            inset
                            :label="`${editedItem.status ? 'Активен': 'Не активен'}`"
                          ></v-switch>
                        </v-sheet>
                        <v-sheet class="pa-2">
                          <v-switch
                            v-model="editedItem.block"
                            inset
                            :label="`${editedItem.block ? 'Заблокирован': 'Не заблокирован'}`"
                          ></v-switch>
                        </v-sheet>
                      </div>
                    </v-col>
                  </v-row>
                </v-container>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="close"
                >
                  Закрыть
                </v-btn>
                <v-btn
                  color="blue darken-1"
                  text
                  @click="save"
                  :loading="loadingEditButton"
                  :disabled="!valid"
                >
                  Сохранить
                </v-btn>
              </v-card-actions>
            </v-card>
          </v-form>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5 justify-center">Удалить пользователя?</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="closeDelete">Отмена</v-btn>
              <v-btn :loading="loadingDeleteButton" color="red darken-1" text @click="deleteItemConfirm">Удалить</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:item.actions="{ item }">
      <v-icon
        small
        class="mr-2"
        @click="editItem(item)"
      >
        mdi-pencil
      </v-icon>
      <v-icon
        v-if="USER.roles.indexOf('ADMIN') >= 0"
        small
        @click="deleteItem(item)"
      >
        mdi-delete
      </v-icon>
    </template>
    <template v-slot:no-data>
      <v-btn
        color="primary"
        @click="initialize"
      >
        Перезагрузить
      </v-btn>
    </template>
  </v-data-table>
</template>

<script>
import api from '@/API/api'
import formatDate from "./utils/formatDate";
import { mapGetters } from 'vuex'

export default {
  name: 'UserSettings',
  data: () => ({
    dialog: false,
    dialogDelete: false,
    loading: false,
    loadingEditButton: false,
    loadingDeleteButton: false,
    height: 450,
    color: "",
    name: "",
    valid: false,
    headers: [
      {
        text: 'Логин',
        align: 'start',
        sortable: false,
        value: 'username',
      },
      { text: 'ФИО', value: 'full_name' },
      { text: 'Телефон', value: 'phone' },
      { text: 'Почта', value: 'email' },
      { text: 'Город', value: 'city' },
      { text: 'Статус', value: 'status' },
      { text: 'Блокировка', value: 'block' },
      { text: 'Права', value: 'roles' },
      { text: 'Дата регистрации', value: 'createdAt' },
      { text: 'Дата изменения', value: 'updatedAt' },
      { text: 'Действия', value: 'actions' },
    ],
    desserts: [],
    roles: [],
    editedIndex: -1,
    editedItem: {
      _id: "",
      username: "",
      name: "",
      surname: "",
      patronymic: "",
      password: "",
      city: "",
      phone: "",
      email: "",
      website: "",
      about: "",
      status: true,
      status_timestamp: "",
      block: false,
      createdAt: "",
      updatedAt: "",
      roles: [],
      leadsman: ''
    },
    defaultItem: {
      username: "",
      name: "",
      surname: "",
      patronymic: "",
      city: "",
      phone: "",
      email: "",
      website: "",
      about: "",
      status: true,
      status_timestamp: true,
      block: false,
      createdAt: "",
      updatedAt: "",
      password: "",
      roles: [],
      leadsman: ''
    },
  }),
  computed: {
    ...mapGetters(["USER"]),
    formTitle () {
      return this.editedIndex === -1 ? 'Новый пользователь' : 'Редактирование'
    },
    formPassword () {
      return this.editedIndex === -1 ? 'Пароль(обязательно)' : 'Пароль'
    },
    formLogin () {
      return this.editedIndex === -1 ? 'Логин(уникальный)' : 'Логин'
    },
  },
  watch: {
    dialog (val) {
      val || this.close()
    },
    dialogDelete (val) {
      val || this.closeDelete()
    },
  },
  created () {
    this.initialize()
    return this.height + window.innerHeight - 100
  },
  methods: {
    formatDate,

    async initialize () {
      this.loading = true
      await api.getUsers()
        .then(res => {
          this.desserts = res.data.users
          this.loading = false
        }).catch(() => {
          this.loading = false
          this.desserts = []
        })
      await api.getRoles().then(res => {
        this.roles = res.data.roles
      })
    },

    editItem (item) {
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem (item) {
      this.editedIndex = this.desserts.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    async deleteItemConfirm () {
      this.loadingDeleteButton = true
      this.desserts.splice(this.editedIndex, 1)
      await api.deleteUser({userId: this.editedItem._id})
        .then(res => {
          res.data.status && (this.loadingDeleteButton = false)
          this.closeDelete()
        })
    },

    close () {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete () {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    async save () {
      this.loadingEditButton = true
      if (this.editedIndex > -1) {
        const val1 = this.desserts[this.editedIndex].status
        const val2 = this.editedItem.status
        const val3 = this.desserts[this.editedIndex].status_timestamp
        const dateChangeStatus = val1 !== val2 ? new Date().toLocaleDateString("ru") : val3
        const item = this.desserts[this.editedIndex]
        Object.assign(item, this.editedItem)
        await api.changeUser({
          _id: this.editedItem._id,
          username: this.editedItem.username,
          name: this.editedItem.name,
          surname: this.editedItem.surname,
          patronymic: this.editedItem.patronymic,
          city: this.editedItem.city,
          phone: this.editedItem.phone,
          email: this.editedItem.email,
          password: this.editedItem.password || "",
          website: this.editedItem.website,
          about: this.editedItem.about,
          status: this.editedItem.status,
          status_timestamp: dateChangeStatus,
          block: this.editedItem.block,
          createdAt: this.editedItem.createdAt,
          updatedAt: this.editedItem.updatedAt,
          roles: this.editedItem.roles,
          leadsman: this.editedItem.leadsman
        })
          .then(res => {
            res.data.status && (this.loadingEditButton = false)
            this.close()
          })
      } else {
        this.desserts.push(this.editedItem)
        await api.addUser({
          _id: this.editedItem._id,
          username: this.editedItem.username,
          name: this.editedItem.name,
          surname: this.editedItem.surname,
          patronymic: this.editedItem.patronymic,
          city: this.editedItem.city,
          phone: this.editedItem.phone,
          email: this.editedItem.email,
          password: this.editedItem.password || "",
          website: this.editedItem.website,
          about: this.editedItem.about,
          status: this.editedItem.status,
          status_timestamp: this.editedItem.status && new Date().toLocaleDateString("ru") || "",
          block: this.editedItem.block,
          createdAt: this.editedItem.createdAt,
          updatedAt: this.editedItem.updatedAt,
          roles: this.editedItem.roles,
          leadsman: this.editedItem.leadsman
        })
          .then(res => {
            res.data.status && this.initialize()
            this.loadingEditButton = false
            this.close()
          })
      }
    },
  },
}
</script>

<style scoped>
/*.container {*/
/*  max-height: calc(100vh - 64px);*/
/*  overflow: hidden;*/
/*}*/
</style>
